From b4052c2617f7f202300ebbf6e4db23341ba15d63 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 04 2017 08:54:36 +0000
Subject: [PATCH 781/1001] Stamp the DB with the Alembic revision on creation


---

diff --git a/hubs/migrations/env.py b/hubs/migrations/env.py
index 7605ce5..e00d82b 100644
--- a/hubs/migrations/env.py
+++ b/hubs/migrations/env.py
@@ -20,13 +20,13 @@ except ImportError:
 
 from hubs.models import BASE
 
-# this is the Alembic Config object, which provides
+# This is the Alembic Config object, which provides
 # access to the values within the .ini file in use.
-config = context.config
-
-# Interpret the config file for Python logging.
-# This line sets up loggers basically.
-fileConfig(config.config_file_name)
+# The config_file_name property may be None when used programatically.
+if context.config.config_file_name is not None:
+    # Interpret the config file for Python logging.
+    # This line sets up loggers basically.
+    fileConfig(context.config.config_file_name)
 
 url = fedmsg_config['hubs.sqlalchemy.uri']
 target_metadata = BASE.metadata
diff --git a/hubs/migrations/versions/26cc11577009_initial_empty_revision.py b/hubs/migrations/versions/26cc11577009_initial_empty_revision.py
new file mode 100644
index 0000000..d142330
--- /dev/null
+++ b/hubs/migrations/versions/26cc11577009_initial_empty_revision.py
@@ -0,0 +1,39 @@
+# This Alembic database migration is part of the Fedora Hubs project.
+# Copyright (C) 2017  Fedora project
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU Affero General Public License for more details.
+#
+# You should have received a copy of the GNU Affero General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+"""
+Initial empty revision.  It does nothing, to the database except allowing
+Alembic to record a revision.
+
+Revision ID: 26cc11577009
+Revises: None
+Create Date: 2017-03-04 09:20:55.915068
+"""
+
+from __future__ import absolute_import, unicode_literals
+
+
+revision = '26cc11577009'
+down_revision = None
+branch_labels = None
+depends_on = None
+
+
+def upgrade():
+    pass
+
+
+def downgrade():
+    pass
diff --git a/hubs/models.py b/hubs/models.py
index 2b7b6d5..23d4f14 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -32,6 +32,9 @@ import random
 import bleach
 import dogpile
 import sqlalchemy as sa
+
+from alembic import command as alembic_command
+from alembic.config import Config as AlembicConfig
 from sqlalchemy import create_engine
 from sqlalchemy.ext.declarative import declarative_base
 from sqlalchemy.orm import sessionmaker
@@ -93,6 +96,11 @@ def init(db_url, debug=False, create=False):
 
     if create:
         BASE.metadata.create_all(engine)
+        # Stamp the database with the lastest Alembic revision:
+        # http://alembic.zzzcomputing.com/en/latest/cookbook.html#building-an-up-to-date-database-from-scratch
+        alembic_cfg = AlembicConfig()
+        alembic_cfg.set_main_option("script_location", "hubs:migrations")
+        alembic_command.stamp(alembic_cfg, "head")
     session = scoped_session(sessionmaker(bind=engine))
     BASE.query = session.query_property()
     return session

